/* ========================================================================== */
/*                                                                            */
/*   robot_test_1.c                                                           */
/*   (c) 2013 Gerhard Hinze                                                   */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  Anschlüsse                                         Anschlüsse             */
/*  Motortreiber:           Bezeichnung                Arduino:               */
/*   VMS                    Motorspannung + (Nur f.Motor)  nc.        !!!!!   */
/*   GND                    Motorspannung - (gemeins. GND) GND                */
/*   +5V                      +5V                          +5V                */
/*   MotorA-1               Motor-1 "-"                   nc. //not connected */
/*   MotorA-2               Motor-1 "+"                   nc. //nicht verbund.*/
/*   MotorB-1               Motor-2 "-"                   nc.                 */
/*   MotorB-2               Motor-2 "+"                   nc.                 */
/* -------------------------------------------------------------------------- */
/*   +++  Die Motoren müssen event. umgepolt werden, Herstellerabhängig +++   */
/* -------------------------------------------------------------------------- */
/*   ENA                    Enable Motor 1 (PWM)                              */
/*   IN1                    DIR-1  Motor 1                                    */
/*   IN2                    Dir-2  Motor 1                                    */
/* -------------------------------------------------------------------------- */
/*   IN3                    DIR-1  Motor 2                                    */
/*   IN4                    Dir-2  Motor 2                                    */
/*   ENB                    Enable Motor 2 (PWM)                              */
/*  ------------------------------------------------------------------------- */
/*                          Definitionen Motoransteuerung                                     */
/*  ------------------------------------------------------------------------- */
#include <NewPing.h> // diese Datei muss im Library-Verzeichnis liegen
#define ENA      5   // Speed Motor 1       = Arduino D5 (PWM)
#define ENB      6   // Speed Motor 2       = Arduino D6 (PWM)
#define IN1      2   // Richtung Motor1 A1  = Arduino D2
#define IN2      4   // Richtung Motor1 A2  = Arduino D4
#define IN3      7   // Richtung Motor2 B1  = Arduino D7
#define IN4      8   // Richtung Motor2 B2  = Arduino D8
#define TRIGGER_PIN  12  // Arduino pin 12 an Trigger Pin am US-Sensor.
#define ECHO_PIN     13  // Arduino pin 13 an Echo Pin am US-Sensor.
#define MAX_DISTANCE 200 // Maximum Abstand zum Objekt (400-500cm).
#define MIN_DISTANCE 10  // Minimum Abstand zum Objekt                 
/*  ------------------------------------------------------------------------- */
/*       Benutzerangaben : Nummerierung für die AnalogPins                    */
/*  ------------------------------------------------------------------------- */
/*    A0 = 14, A1 = 15, A2 = 16, A3 = 17, A4 = 18, A5 = 19                    */
/*  ------------------------------------------------------------------------- */
/*    Geschrieben für ein Arduino-UNO mit L298 H-Brücke als Motortreiber      */
/*    Objektsuche frontal mit Ultraschall-Sensor HC-04                        */
/*                                                                            */
/*                                                                            */
/*  ------------------------------------------------------------------------- */

NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE);
void setup()
{
  pinMode(ENA, OUTPUT);  //Setze Pins als Ausgang
  pinMode(ENB, OUTPUT);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
/* Fahre erstmals vorwärtz mit Speed =100   / = 39% Fullspeed                 */
  digitalWrite(IN1,LOW);
  digitalWrite(IN2,HIGH);
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,HIGH);
              
  analogWrite(ENA, 100); //setze Motorspeed  (100/255 = 39)% duty cycle (slow)
  analogWrite(ENB, 100); //setze Motorspeed  (100/255 = 39)% duty cycle (slow)
  
}
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/* Linker Motor fahre vorwärtz */
void FOR_M1() {
  digitalWrite(IN1,LOW);
  digitalWrite(IN2,HIGH);
                    } 
/* Rechter Motor fahre vorwärtz */
void FOR_M2() {
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,HIGH);
}
/* Linker Motor fahre rückwärtz */
void REV_M1() 
{
  digitalWrite(IN1,HIGH);
  digitalWrite(IN2,LOW);
}
/* Rechter Motor fahre rückwärtz */
void REV_M2() {
  digitalWrite(IN3,HIGH);
  digitalWrite(IN4,LOW);
}
void HALT()
{
analogWrite(ENA, 0); // STOP M1
analogWrite(ENB, 0); // STOP M2
}
int DISTANCE()
{
if (millis() >= pingTimer) { // pingSpeed milliseconds since last ping, do another ping.
    pingTimer += pingSpeed;    // Set the next ping time.
}
   int cm = sonar.ping_cm();  // Send out the ping, get the results in centimeters.
    
    return cm;
}
void loop()
{
if (DISTANCE() < MIN_DISTANCE)  // Abstand kleiner als das Minimum(10cm)
                                // dann halten vorerst...später ausweichen
{                             
HALT();
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
}
